- leetcode: Binary Tree Level Order Traversal | LeetCode OJ
- lintcode: (69) Binary Tree Level Order Traversal
Given a binary tree, return the level order traversal of its nodes' values. (ie, from left to right, level by level).
Given binary tree {3,9,20,#,#,15,7}
,
3
/ \
9 20
/ \
15 7
return its level order traversal as:
[
[3],
[9,20],
[15,7]
]
Challenge 1: Using only 1 queue to implement it.
Challenge 2: Use DFS algorithm to do it.
此题为广搜的基础题,使用一个队列保存每层的节点即可。出队和将子节点入队的实现使用 for 循环,将每一轮的节点输出。
/**
* Definition of TreeNode:
* class TreeNode {
* public:
* int val;
* TreeNode *left, *right;
* TreeNode(int val) {
* this->val = val;
* this->left = this->right = NULL;
* }
* }
*/
class Solution {
/**
* @param root: The root of binary tree.
* @return: Level order a list of lists of integer
*/
public:
vector<vector<int> > levelOrder(TreeNode *root) {
vector<vector<int> > result;
if (NULL == root) {
return result;
}
queue<TreeNode *> q;
q.push(root);
while (!q.empty()) {
vector<int> list;
int size = q.size(); // keep the queue size first
for (int i = 0; i != size; ++i) {
TreeNode * node = q.front();
q.pop();
list.push_back(node->val);
if (node->left) {
q.push(node->left);
}
if (node->right) {
q.push(node->right);
}
}
result.push_back(list);
}
return result;
}
};
/**
* Definition for a binary tree node.
* public class TreeNode {
* int val;
* TreeNode left;
* TreeNode right;
* TreeNode(int x) { val = x; }
* }
*/
public class Solution {
public List<List<Integer>> levelOrder(TreeNode root) {
List<List<Integer>> result = new ArrayList<List<Integer>>();
if (root == null) return result;
Queue<TreeNode> q = new LinkedList<TreeNode>();
q.offer(root);
while (!q.isEmpty()) {
List<Integer> list = new ArrayList<Integer>();
int qSize = q.size();
for (int i = 0; i < qSize; i++) {
TreeNode node = q.poll();
list.add(node.val);
// push child node into queue
if (node.left != null) q.offer(node.left);
if (node.right != null) q.offer(node.right);
}
result.add(new ArrayList<Integer>(list));
}
return result;
}
}
- 异常,还是异常
- 使用STL的
queue
数据结构,将root
添加进队列 - 遍历当前层所有节点,注意需要先保存队列大小,因为在入队出队时队列大小会变化
list
保存每层节点的值,每次使用均要初始化
使用辅助队列,空间复杂度 $$O(n)$$
, 时间复杂度 $$O(n)$$
.
- leetcode: Binary Tree Level Order Traversal II | LeetCode OJ
- lintcode: (70) Binary Tree Level Order Traversal II
Given a binary tree, return the bottom-up level order traversal of its nodes' values.
(ie, from left to right, level by level from leaf to root).
Example
Given binary tree {3,9,20,#,#,15,7},
3
/ \
9 20
/ \
15 7
return its bottom-up level order traversal as:
[
[15,7],
[9,20],
[3]
]
此题在普通的 BFS 基础上增加了逆序输出,简单的实现可以使用辅助栈或者最后对结果逆序。
/**
* Definition of TreeNode:
* public class TreeNode {
* public int val;
* public TreeNode left, right;
* public TreeNode(int val) {
* this.val = val;
* this.left = this.right = null;
* }
* }
*/
public class Solution {
/**
* @param root: The root of binary tree.
* @return: buttom-up level order a list of lists of integer
*/
public ArrayList<ArrayList<Integer>> levelOrderBottom(TreeNode root) {
ArrayList<ArrayList<Integer>> result = new ArrayList<ArrayList<Integer>>();
if (root == null) return result;
Stack<ArrayList<Integer>> s = new Stack<ArrayList<Integer>>();
Queue<TreeNode> q = new LinkedList<TreeNode>();
q.offer(root);
while (!q.isEmpty()) {
int qLen = q.size();
ArrayList<Integer> aList = new ArrayList<Integer>();
for (int i = 0; i < qLen; i++) {
TreeNode node = q.poll();
aList.add(node.val);
if (node.left != null) q.offer(node.left);
if (node.right != null) q.offer(node.right);
}
s.push(aList);
}
while (!s.empty()) {
result.add(s.pop());
}
return result;
}
}
/**
* Definition of TreeNode:
* public class TreeNode {
* public int val;
* public TreeNode left, right;
* public TreeNode(int val) {
* this.val = val;
* this.left = this.right = null;
* }
* }
*/
public class Solution {
/**
* @param root: The root of binary tree.
* @return: buttom-up level order a list of lists of integer
*/
public ArrayList<ArrayList<Integer>> levelOrderBottom(TreeNode root) {
ArrayList<ArrayList<Integer>> result = new ArrayList<ArrayList<Integer>>();
if (root == null) return result;
Queue<TreeNode> q = new LinkedList<TreeNode>();
q.offer(root);
while (!q.isEmpty()) {
int qLen = q.size();
ArrayList<Integer> aList = new ArrayList<Integer>();
for (int i = 0; i < qLen; i++) {
TreeNode node = q.poll();
aList.add(node.val);
if (node.left != null) q.offer(node.left);
if (node.right != null) q.offer(node.right);
}
result.add(aList);
}
Collections.reverse(result);
return result;
}
}
Java 中 Queue 是接口,通常可用 LinkedList 实例化。
时间复杂度为 $$O(n)$$
, 使用了队列或者辅助栈作为辅助空间,空间复杂度为 $$O(n)$$
.
- leetcode: Maximum Depth of Binary Tree | LeetCode OJ
- lintcode: (97) Maximum Depth of Binary Tree
Given a binary tree, find its maximum depth.
The maximum depth is the number of nodes along the longest path from the root node down to the farthest leaf node.
Given a binary tree as follow:
1
/ \
2 3
/ \
4 5
The maximum depth is 3
.
树遍历的题最方便的写法自然是递归,不过递归调用的层数过多可能会导致栈空间溢出,因此需要适当考虑递归调用的层数。我们首先来看看使用递归如何解这道题,要求二叉树的最大深度,直观上来讲使用深度优先搜索判断左右子树的深度孰大孰小即可,从根节点往下一层树的深度即自增1,遇到NULL
时即返回0。
由于对每个节点都会使用一次maxDepth
,故时间复杂度为 $$O(n)$$
, 树的深度最大为 $$O(n)$$
之间。
/**
* Definition of TreeNode:
* class TreeNode {
* public:
* int val;
* TreeNode *left, *right;
* TreeNode(int val) {
* this->val = val;
* this->left = this->right = NULL;
* }
* }
*/
class Solution {
public:
/**
* @param root: The root of binary tree.
* @return: An integer
*/
int maxDepth(TreeNode *root) {
if (NULL == root) {
return 0;
}
int left_depth = maxDepth(root->left);
int right_depth = maxDepth(root->right);
return max(left_depth, right_depth) + 1;
}
};
/**
* Definition of TreeNode:
* public class TreeNode {
* public int val;
* public TreeNode left, right;
* public TreeNode(int val) {
* this.val = val;
* this.left = this.right = null;
* }
* }
*/
public class Solution {
/**
* @param root: The root of binary tree.
* @return: An integer.
*/
public int maxDepth(TreeNode root) {
// write your code here
if (root == null) {
return 0;
}
return Math.max(maxDepth(root.left), maxDepth(root.right)) + 1;
}
}
使用递归可能会导致栈空间溢出,这里使用显式栈空间(使用堆内存)来代替之前的隐式栈空间。从上节递归版的代码(先处理左子树,后处理右子树,最后返回其中的较大值)来看,是可以使用类似后序遍历的迭代思想去实现的。
首先使用后序遍历的模板,在每次迭代循环结束处比较栈当前的大小和当前最大值max_depth
进行比较。
/**
* Definition of TreeNode:
* class TreeNode {
* public:
* int val;
* TreeNode *left, *right;
* TreeNode(int val) {
* this->val = val;
* this->left = this->right = NULL;
* }
* }
*/
class Solution {
public:
/**
* @param root: The root of binary tree.
* @return: An integer
*/
int maxDepth(TreeNode *root) {
if (NULL == root) {
return 0;
}
TreeNode *curr = NULL, *prev = NULL;
stack<TreeNode *> s;
s.push(root);
int max_depth = 0;
while(!s.empty()) {
curr = s.top();
if (!prev || prev->left == curr || prev->right == curr) {
if (curr->left) {
s.push(curr->left);
} else if (curr->right){
s.push(curr->right);
}
} else if (curr->left == prev) {
if (curr->right) {
s.push(curr->right);
}
} else {
s.pop();
}
prev = curr;
if (s.size() > max_depth) {
max_depth = s.size();
}
}
return max_depth;
}
};
在使用了递归/后序遍历求解树最大深度之后,我们还可以直接从问题出发进行分析,树的最大深度即为广度优先搜索中的层数,故可以直接使用广度优先搜索求出最大深度。
/**
* Definition of TreeNode:
* class TreeNode {
* public:
* int val;
* TreeNode *left, *right;
* TreeNode(int val) {
* this->val = val;
* this->left = this->right = NULL;
* }
* }
*/
class Solution {
public:
/**
* @param root: The root of binary tree.
* @return: An integer
*/
int maxDepth(TreeNode *root) {
if (NULL == root) {
return 0;
}
queue<TreeNode *> q;
q.push(root);
int max_depth = 0;
while(!q.empty()) {
int size = q.size();
for (int i = 0; i != size; ++i) {
TreeNode *node = q.front();
q.pop();
if (node->left) {
q.push(node->left);
}
if (node->right) {
q.push(node->right);
}
}
++max_depth;
}
return max_depth;
}
};
/**
* Definition of TreeNode:
* public class TreeNode {
* public int val;
* public TreeNode left, right;
* public TreeNode(int val) {
* this.val = val;
* this.left = this.right = null;
* }
* }
*/
public class Solution {
/**
* @param root: The root of binary tree.
* @return: An integer.
*/
public int maxDepth(TreeNode root) {
if (root == null) {
return 0;
}
int depth = 0;
Queue<TreeNode> q = new LinkedList<TreeNode>();
q.offer(root);
while (!q.isEmpty()) {
depth++;
int qLen = q.size();
for (int i = 0; i < qLen; i++) {
TreeNode node = q.poll();
if (node.left != null) q.offer(node.left);
if (node.right != null) q.offer(node.right);
}
}
return depth;
}
}
广度优先中队列的使用中,qLen
需要在for 循环遍历之前获得,因为它是一个变量。
最坏情况下空间复杂度为 $$O(n)$$
, 遍历每一个节点,时间复杂度为 $$O(n)$$
,
- leetcode: Balanced Binary Tree | LeetCode OJ
- lintcode: (93) Balanced Binary Tree
Given a binary tree, determine if it is height-balanced.
For this problem, a height-balanced binary tree is defined as a binary tree in which the depth of the two subtrees of every node never differ by more than 1.
Given binary tree A={3,9,20,#,#,15,7}
, B={3,#,20,15,7}
A) 3 B) 3
/ \ \
9 20 20
/ \ / \
15 7 15 7
The binary tree A is a height-balanced binary tree, but B is not.
根据题意,平衡树的定义是两子树的深度差最大不超过1,显然使用递归进行分析较为方便。既然使用递归,那么接下来就需要分析递归调用的终止条件。和之前的 Maximum Depth of Binary Tree | Algorithm 类似,NULL == root
必然是其中一个终止条件,返回0
;根据题意还需的另一终止条件应为「左右子树高度差大于1」,但对应此终止条件的返回值是多少?——INT_MAX
or INT_MIN
?想想都不合适,为何不在传入参数中传入bool
指针或者bool
引用咧?并以此变量作为最终返回值,此法看似可行,先来看看鄙人最开始想到的这种方法。
/**
* Definition of TreeNode:
* class TreeNode {
* public:
* int val;
* TreeNode *left, *right;
* TreeNode(int val) {
* this->val = val;
* this->left = this->right = NULL;
* }
* }
*/
class Solution {
public:
/**
* @param root: The root of binary tree.
* @return: True if this Binary tree is Balanced, or false.
*/
bool isBalanced(TreeNode *root) {
if (NULL == root) {
return true;
}
bool result = true;
maxDepth(root, result);
return result;
}
private:
int maxDepth(TreeNode *root, bool &isBalanced) {
if (NULL == root) {
return 0;
}
int leftDepth = maxDepth(root->left, isBalanced);
int rightDepth = maxDepth(root->right, isBalanced);
if (abs(leftDepth - rightDepth) > 1) {
isBalanced = false;
// speed up the recursion process
return INT_MAX;
}
return max(leftDepth, rightDepth) + 1;
}
};
如果在某一次子树高度差大于1时,返回INT_MAX
以减少不必要的计算过程,加速整个递归调用的过程。
初看起来上述代码好像还不错的样子,但是在看了九章的实现后,瞬间觉得自己弱爆了... 首先可以确定abs(leftDepth - rightDepth) > 1
肯定是需要特殊处理的,如果返回-1
呢?咋一看似乎在下一步返回max(leftDepth, rightDepth) + 1
时会出错,再进一步想想,我们能否不让max...
这一句执行呢?如果返回了-1
,其接盘侠必然是leftDepth
或者rightDepth
中的一个,因此我们只需要在判断子树高度差大于1的同时也判断下左右子树深度是否为-1
即可都返回-1
,不得不说这种处理方法要精妙的多,赞!
/**
* forked from http://www.jiuzhang.com/solutions/balanced-binary-tree/
* Definition of TreeNode:
* class TreeNode {
* public:
* int val;
* TreeNode *left, *right;
* TreeNode(int val) {
* this->val = val;
* this->left = this->right = NULL;
* }
* }
*/
class Solution {
public:
/**
* @param root: The root of binary tree.
* @return: True if this Binary tree is Balanced, or false.
*/
bool isBalanced(TreeNode *root) {
return (-1 != maxDepth(root));
}
private:
int maxDepth(TreeNode *root) {
if (NULL == root) {
return 0;
}
int leftDepth = maxDepth(root->left);
int rightDepth = maxDepth(root->right);
if (leftDepth == -1 || rightDepth == -1 || \
abs(leftDepth - rightDepth) > 1) {
return -1;
}
return max(leftDepth, rightDepth) + 1;
}
};
/**
* Definition for a binary tree node.
* public class TreeNode {
* int val;
* TreeNode left;
* TreeNode right;
* TreeNode(int x) { val = x; }
* }
*/
public class Solution {
public boolean isBalanced(TreeNode root) {
return maxDepth(root) != -1;
}
private int maxDepth(TreeNode root) {
if (root == null) return 0;
int leftDepth = maxDepth(root.left);
int rightDepth = maxDepth(root.right);
if (leftDepth == -1 || rightDepth == -1 ||
Math.abs(leftDepth - rightDepth) > 1) {
return -1;
}
return 1 + Math.max(leftDepth, rightDepth);
}
}
抓住两个核心:子树的高度以及高度之差,返回值应该包含这两种信息。
遍历所有节点各一次,时间复杂度为 $$O(n)$$
, 使用了部分辅助变量,空间复杂度 $$O(1)$$
.